using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using TargetController.Common;
using VirtuosoComponentLibrary;
using CuriosityBoardLibrary;

namespace SerialPortUART_Host
{
	public class SerialPortUART_TargetViewModel : SerialPortUART_TargetModel
	{
		public SerialPortUART_TargetViewModel()
		{
			InitializeComponents();
		}

		public SerialPortUART_TargetViewModel (ITargetHostingConfiguration TargetConfiguration) : base(TargetConfiguration)
		{
			InitializeComponents();
		}

		private void InitializeComponents()
		{
			// Add component(s) here....
			_PowerButton = new PowerButtonViewModel(this, "VirtualDeviceIsPowered", LEDTileImage.Tile1, PowerButtonColor.Blue);
            _SerialPortVM = new StreamToGlobalAdapterViewModel(this, UpStreams, DownStreams, "Control1");
        }

        private PowerButtonViewModel _PowerButton;
        public PowerButtonViewModel PowerButton
        {
            get
            {
                return _PowerButton;
            }
        }

        private StreamToGlobalAdapterViewModel _SerialPortVM;
        public StreamToGlobalAdapterViewModel SerialPortVM
        {
            get
            {
                return _SerialPortVM;
            }
        }
	}
}
