/************************************************************************************
*
* This file is controlled by Virtuoso........
*
************************************************************************************/
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using LocalVisualStudioCTargetController;
using System.IO;
using TargetController.Common;
using VirtuosoComponentLibrary.SettingsManager;

namespace SerialPortUART_Host
{
   public class SerialPortUART_TargetModel : LocalVisualStudioCTargetBackgroundController
   {
      public List<string> UpStreams;
      public List<string> DownStreams;
      public List<string> AllStreams;
      public PersistentSettings Settings;

      public SerialPortUART_TargetModel()
      {
      }
      
      public SerialPortUART_TargetModel(ITargetHostingConfiguration TargetConfiguration) : base(TargetConfiguration)
      {
         UpStreams = new List<string>()
         {
            "UpStream1",
         };

         DownStreams = new List<string>()
         {
            "DownStream1",
         };

         AllStreams = UpStreams.Concat(DownStreams).ToList();
         Settings = new PersistentSettings();
      }

      public bool VirtualDeviceIsPowered
      {
         get { return GetPowerState(); }
         set
         {
            SetPowerState("VirtualDeviceIsPowered", value); 
            if (value)  { TargetController.RunTarget(); } else  { TargetController.PauseTarget(); }
         }
      }

      public byte[] UpStream1
      {
         get { return base.GetStreamProperty("UpStream1"); }
         set { throw new Exception("This is an output property and cannot be 'set'"); }
      }

      public byte[] DownStream1
      {
         get { throw new Exception("This is an input property and cannot be 'get'"); }
         set { base.SetStreamProperty("DownStream1", value); }
      }

   }
}
